﻿package 
{
	import flash.display.Sprite;
	import flash.display.Shape;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.ui.Mouse;
	public class Fibonacci extends Sprite
	{
		private var centerX:Number;
		private var centerY:Number;
		private var stack:Array = new Array();
		
		private var i:Number;
		
		private var dirx:Number;
		private var diry:Number;
		
		private var pos_negx:Number;
		private var pos_negy:Number;
		
		public function Fibonacci()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(MouseEvent.CLICK,clickHandler);
		}
		private function clickHandler(e:MouseEvent):void
		{
			pos_negx = (int(Math.random()*2) - 1 | 1);
			pos_negy = (int(Math.random()*2) - 1 | 1);
			centerX = e.stageX;
			centerY = e.stageY;
			dirx = pos_negx*Math.random()*20;
			diry = pos_negy*Math.random()*20;
			i = 0;
			addEventListener(Event.ENTER_FRAME,fibonDraw);
		}
		private function fibonDraw(e:Event):void
		{
			if(i<220){
				stack[i] = new Object();
				stack[i].s = new Shape();
				stack[i].s.graphics.lineStyle(3/220*i+1,0xffffff,1/220*i);
				
				//stack[i]._x = pos_negx*(Math.cos(Math.PI*2/220*i)*dirx+i*pos_negy*dirx/10)+mouseX-centerX;
				//stack[i]._y = pos_negx*(Math.sin(Math.PI*2/220*i)*diry+i*pos_negx*diry/10)+mouseY-centerY;
				
				stack[i]._x = Math.cos(mouseX-centerX*i)+mouseX-centerX;
				stack[i]._y = Math.sin(mouseY-centerY*i)+mouseY-centerY;
				
				stack[i].s.x = centerX;
				stack[i].s.y = centerY;
				if (i > 0) {
					stack[i].s.graphics.moveTo(stack[i-1]._x,stack[i-1]._y);
					stack[i].s.graphics.lineTo(stack[i]._x,stack[i]._y);
					addChild(stack[i].s);
				}
				i++;
			}else{
				removeEventListener(Event.ENTER_FRAME,fibonDraw);
			}
		}
	}
}